const path = require('path')
const rra = require('recursive-readdir-async')
const dir = path.resolve(_flitter.directories.models)

exports.up = async (ctx) => {
    const flap = ctx.flap

    const files = await rra.list(dir)
    for ( let key in files ){
        flap.find_replace_file(files[key].fullname, /{(?:\n|.)*(?:})/, `{
    schema: %orig,
}`)
    }
}

exports.down = async (ctx) => {
    const flap = ctx.flap
    const schema_matcher = /schema:\s*{(?:(?:\n|\s)*(?:[A-Za-z_])+\s*:\s*(?:(?:{(?:\n|\s|[a-zA-Z0-9:\.'",()])*})|(?:[a-zA-Z_:'"0-9]))+(?:,|\n))*(?:\n|\s)*}(?:,)?/

    const files = await rra.list(dir)
    for ( let key in files ){
        flap.find_replace_file(files[key].fullname, schema_matcher, `%orig`, (m) => {

            m = m.replace(/schema\s*:\s*{/, '')

            m = m.split('').reverse().join('').replace(/,?}/, '').split('').reverse().join('')

            return m
        })
    }
}
